import type * as nodes from '../../nodes';
import { BaseThrowVisitor } from '../BaseThrowVisitor';
type InstructionNodeInput = ({
    kind: 'arg';
} & InstructionNodeArg) | ({
    kind: 'account';
} & nodes.InstructionNodeAccount);
type InstructionNodeArg = {
    name: string;
    defaultsTo: nodes.InstructionNodeArgDefaults;
};
export type ResolvedInstructionAccount = nodes.InstructionNodeAccount & {
    kind: 'account';
    isPda: boolean;
    dependsOn: nodes.InstructionNodeInputDependency[];
    resolvedIsSigner: boolean | 'either';
    resolvedIsOptional: boolean;
};
export type ResolvedInstructionArg = InstructionNodeArg & {
    kind: 'arg';
    dependsOn: nodes.InstructionNodeInputDependency[];
};
export type ResolvedInstructionInput = ResolvedInstructionAccount | ResolvedInstructionArg;
export declare class GetResolvedInstructionInputsVisitor extends BaseThrowVisitor<ResolvedInstructionInput[]> {
    protected stack: InstructionNodeInput[];
    protected resolved: ResolvedInstructionInput[];
    protected visitedAccounts: Map<string, ResolvedInstructionAccount>;
    protected visitedArgs: Map<string, ResolvedInstructionArg>;
    protected error: string | null;
    getError(): string | null;
    visitInstruction(instruction: nodes.InstructionNode): ResolvedInstructionInput[];
    resolveInstructionInput(instruction: nodes.InstructionNode, input: InstructionNodeInput): void;
    resolveInstructionAccount(instruction: nodes.InstructionNode, account: nodes.InstructionNodeAccount & {
        kind: 'account';
    }): ResolvedInstructionAccount;
    resolveInstructionArg(instruction: nodes.InstructionNode, arg: InstructionNodeArg & {
        kind: 'arg';
    }): ResolvedInstructionArg;
    resolveInstructionDependencies(instruction: nodes.InstructionNode, parent: InstructionNodeInput, dependencies: nodes.InstructionNodeInputDependency[]): void;
}
export {};
