import * as nodes from '../../nodes';
import { Dependency } from '../Dependency';
import { InstructionNodeAccountDefaultsInput } from './SetInstructionAccountDefaultValuesVisitor';
import { NodeTransformer, TransformNodesVisitor } from './TransformNodesVisitor';
export type InstructionUpdates = NodeTransformer<nodes.InstructionNode> | {
    delete: true;
} | (InstructionMetadataUpdates & {
    args?: Record<string, string>;
    extraArgs?: nodes.TypeStructNode | nodes.TypeDefinedLinkNode | null;
});
export type InstructionMetadataUpdates = Partial<Omit<nodes.InstructionNodeMetadata, 'bytesCreatedOnChain'> & {
    bytesCreatedOnChain: InstructionNodeBytesCreatedOnChainInput | null;
    accounts: InstructionAccountUpdates;
}>;
export type InstructionAccountUpdates = Record<string, Partial<Omit<nodes.InstructionNodeAccount, 'defaultsTo'> & {
    defaultsTo: InstructionNodeAccountDefaultsInput;
}>>;
type InstructionNodeBytesCreatedOnChainInput = {
    kind: 'number';
    value: number;
    includeHeader?: boolean;
} | {
    kind: 'arg';
    name: string;
    includeHeader?: boolean;
} | {
    kind: 'account';
    name: string;
    dependency?: Dependency;
    includeHeader?: boolean;
} | {
    kind: 'resolver';
    name: string;
    dependency?: Dependency;
};
export declare class UpdateInstructionsVisitor extends TransformNodesVisitor {
    readonly map: Record<string, InstructionUpdates>;
    protected allAccounts: Map<string, nodes.AccountNode>;
    constructor(map: Record<string, InstructionUpdates>);
    visitRoot(root: nodes.RootNode): nodes.Node | null;
    handleMetadata(metadataUpdates: InstructionMetadataUpdates): Partial<nodes.InstructionNodeMetadata>;
    handleInstructionAccount(account: nodes.InstructionNodeAccount, accountUpdates: InstructionAccountUpdates): nodes.InstructionNodeAccount;
}
export {};
